@@ -304,6 +304,19 @@ _filter_testdir_and_scratch()
fi
}
+_filter_scratch_pool_short()
+{
+ SHORT=""
+
+ for DEV in $SCRATCH_DEV_POOL
+ do
+ SHORT="$SHORT $(echo $DEV| rev | awk -F / '{print $1}' | rev)"
+ done
+
+ FILTER_STRING=$(echo $SHORT | sed -e 's/\s\+/\\\|/g')
+ sed -e "s,$FILTER_STRING,SCRATCH_DEV,g"
+}
+
# Turn any device in the scratch pool into SCRATCH_DEV
_filter_scratch_pool()
{
new file mode 100755
@@ -0,0 +1,94 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Oracle. All Rights Reserved.
+#
+# FS QA Test 219
+#
+# Test for seed device-delete on a sprouted FS.
+# Requires kernel patch
+# btrfs: initialize sysfs devid and device link for seed device
+#
+# Steps:
+# Create a seed FS. Add a RW device to make it sprout FS and then delete
+# the seed device.
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/filter.btrfs
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+_require_test
+_require_scratch_dev_pool 2
+
+_scratch_dev_pool_get 2
+
+seed=$(echo $SCRATCH_DEV_POOL | awk '{print $1}')
+sprout=$(echo $SCRATCH_DEV_POOL | awk '{print $2}')
+
+_mkfs_dev $seed
+_mount $seed $SCRATCH_MNT
+
+$XFS_IO_PROG -f -d -c "pwrite -S 0xab 0 1M" $SCRATCH_MNT/foo > /dev/null
+_scratch_unmount
+$BTRFS_TUNE_PROG -S 1 $seed
+
+# Mount the seed device and add the rw device
+_mount -o ro $seed $SCRATCH_MNT
+$BTRFS_UTIL_PROG device add -f $sprout $SCRATCH_MNT
+_scratch_unmount
+
+# Now remount
+_mount $sprout $SCRATCH_MNT
+$XFS_IO_PROG -f -d -c "pwrite -S 0xcd 0 1M" $SCRATCH_MNT/bar > /dev/null
+
+echo --- before delete ----
+UUID=$($BTRFS_UTIL_PROG filesystem show -m $SCRATCH_MNT | head -1 | \
+ awk '{print $4}')
+find /sys/fs/btrfs/$UUID/devinfo/ | rev | awk -F / '{print $1}' | rev
+find /sys/fs/btrfs/$UUID/devices/ | rev | awk -F / '{print $1}' | rev | \
+ _filter_scratch_pool_short
+echo
+od -x $SCRATCH_MNT/foo
+od -x $SCRATCH_MNT/bar
+
+$BTRFS_UTIL_PROG device delete $seed $SCRATCH_MNT
+_scratch_unmount
+_btrfs_forget_or_module_reload
+_mount $sprout $SCRATCH_MNT
+
+echo --- after delete ----
+find /sys/fs/btrfs/$UUID/devinfo/ | rev | awk -F / '{print $1}' | rev
+find /sys/fs/btrfs/$UUID/devices/ | rev | awk -F / '{print $1}' | rev | \
+ _filter_scratch_pool_short
+echo
+od -x $SCRATCH_MNT/foo
+od -x $SCRATCH_MNT/bar
+
+_scratch_dev_pool_put
+
+# success, all done
+status=0
+exit
new file mode 100644
@@ -0,0 +1,39 @@
+QA output created by 219
+--- before delete ----
+
+1
+in_fs_metadata
+replace_target
+writeable
+missing
+2
+in_fs_metadata
+replace_target
+writeable
+missing
+
+SCRATCH_DEV
+SCRATCH_DEV
+
+0000000 abab abab abab abab abab abab abab abab
+*
+4000000
+0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
+*
+4000000
+--- after delete ----
+
+2
+in_fs_metadata
+replace_target
+writeable
+missing
+
+SCRATCH_DEV
+
+0000000 abab abab abab abab abab abab abab abab
+*
+4000000
+0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
+*
+4000000
@@ -221,3 +221,4 @@
216 auto quick seed
217 auto quick trim dangerous
218 auto quick volume
+219 auto quick volume seed
This is a regression test for the issue fixed by the kernel patch btrfs: initialize sysfs devid and device link for seed device In this test case, we verify the seed device delete on a sprouted filesystem. This patch also adds a filter to filter the scratch pool devices without the device path. Signed-off-by: Anand Jain <anand.jain@oracle.com> --- common/filter | 13 +++++++ tests/btrfs/219 | 94 +++++++++++++++++++++++++++++++++++++++++++++ tests/btrfs/219.out | 39 +++++++++++++++++++ tests/btrfs/group | 1 + 4 files changed, 147 insertions(+) create mode 100755 tests/btrfs/219 create mode 100644 tests/btrfs/219.out